#!/bin/sh
# Create file lists
D=`pwd`/debian
T=`pwd`/file_lists_tmp
L=`pwd`/file_lists
rm -rf $L; mkdir -p $L
rm -rf $T; mkdir -p $T
cp $D/*.install $T
pushd $T
    for f in $T/*.install
    do
	subst "s/^debian\/tmp//" $f
	subst "s/^debian\/local.*$//" $f
	subst "s/^.*debian\/patches.*$//" $f
	subst "s/^\/etc.*$//" $f
	subst "s/^.*etc\/kde3.*$//" $f
	subst "s/.*\/usr\/share\/config\/.*//" $f
	subst "s/.*\/usr\/share\/doc\/.*//" $f
	subst "s/\(\/usr\/lib\/.*\)\.so.*/\1.so*/" $f
	subst "s/.*\/usr\/share\/config\/kdm.*//" $f
	# filelist changes
	subst "s/.*\/usr\/lib\/krandrinithack\.so.*//" $f
	subst "s/.*\/usr\/share\/apps\/konqueror\/profiles\/filepreview//" $f
	#
	mv $f $f.tmp
	    grep -v -e.*\.la{,\ }$        $f.tmp >> $f
	    grep -e\/usr\/lib\/kde3\/.*\.la{,\ }$   $f.tmp >> $f ||:
	rm -f $f.tmp
    done

    ls -1 *-dev.install | \
    while read f
    do
	cat $f | \
	    sed "s/\/usr\/include\/kde/\/usr\/include/" \
	    >> $L/devel
    done

    ls -1 *.install | grep -v -e\-dev\.install | \
    while read f
    do
	P=`echo $f| sed "s/\.install$//"`
	case $P in
	    xfonts-konsole)
		;;
	    kdm)
		cat $f | \
		    grep -v /usr/share/apps/kdm/pics/users \
		    >> $L/kdm
		;;
	    kdeprint)
		cat $f >> $L/kdeprint
		;;
	    kcontrol)
		cat $f | \
		    grep -v -e{kshorturifilter,kuriikwsfilter,kurisearchfilter,localdomainurifilter} \
		    >> $L/kcontrol
		grep -e{kshorturifilter,kuriikwsfilter,kurisearchfilter,localdomainurifilter} \
		    $f >> $L/libkonq
		;;
	    konqueror|konqueror-nsplugins)
		cat $f >> $L/konqueror
		;;
	    libkonq*)
		cat $f >> $L/libkonq
		;;
	    kdebase-kio-plugins)
		subst "s/^.*\/smb\.protocol$//" $f
		subst "s/^.*kio_smb\..*$//" $f
		cat $f >> $L/kio
		;;
	    kate|kappfinder|kdesktop|kfind|khelpcenter|kicker|klipper|kmenuedit|konsole|kpager|kpersonalizer|ksmserver|ksplash|ksysguard|ksysguardd|ktip|kwin)
		cat $f | \
		    grep -v /usr/share/apps/ksplash/pics | \
		    grep -v /usr/share/apps/ksplash/Themes/Default | \
		    grep -v -e{\/usr\/bin\/kwrited,\/usr\/bin\/konsole} \
		    >> $L/wm
		;;
	    *)
		cat $f | \
		    grep -v -e{\/usr\/bin\/kcheckpass,\/usr\/bin\/kdesud} \
		    >> $L/libs
		;;
	esac
    done

    for f in $L/*
    do
	mv $f $f.tmp
	cat $f.tmp | sort| uniq > $f
	rm -f $f.tmp
    done
    
cat >$L/kcmshell << __EOF__
%_bindir/kcmshell
/usr/lib/kde3/kcmshell.*
/usr/lib/kde3/kcm_konq.*
/usr/lib/kde3/kcm_filetypes.*
/usr/lib/kde3/kcm_kio.*
/usr/lib/kde3/kcm_konqhtml.*
/usr/lib/kde3/kcm_crypto.*
/usr/lib/kde3/kcm_kurifilt.*
/usr/lib/kde3/kcm_css.*
%applnk/.hidden/filebehavior.desktop
%applnk/.hidden/fileappearance.desktop
%applnk/.hidden/filepreviews.desktop
%applnk/.hidden/kcmkonq.desktop
%applnk/.hidden/konqhtml.desktop
%applnk/.hidden/socks.desktop
%kdemenu/filetypes.desktop
%kdemenu/lanbrowser.desktop
%kdemenu/netpref.desktop
%kdemenu/proxy.desktop
%kdemenu/cookies.desktop
%kdemenu/cache.desktop
%kdemenu/ebrowsing.desktop
%kdemenu/kcmcss.desktop
%kdemenu/khtml_behavior.desktop
%kdemenu/khtml_fonts.desktop
%kdemenu/khtml_java_js.desktop
%kdemenu/khtml_plugins.desktop
%kdemenu/useragent.desktop
%kdemenu/crypto.desktop
%applnk/Settings/WebBrowsing/khtml_appearance.desktop
%applnk/Settings/WebBrowsing/nsplugin.desktop
%applnk/.hidden/smb.desktop
%applnk/Settings/WebBrowsing/smb.desktop
/usr/share/apps/kcmcss
%_iconsdir/*/*/apps/cache.png
%_iconsdir/*/*/apps/proxy.png
%_iconsdir/*/*/apps/cookie.png
%_iconsdir/*/*/apps/enhanced_browsing.png
%_iconsdir/*/*/apps/filetypes.png
%_iconsdir/*/*/apps/samba.png
%_iconsdir/*/*/apps/stylesheet.png
%_iconsdir/*/*/apps/agent.png
/usr/share/services/searchproviders
/usr/share/services/useragentstrings
/usr/share/servicetypes/searchprovider.desktop
/usr/share/servicetypes/uasprovider.desktop
__EOF__

cat $L/kcmshell | perl -pi -e "s/(.*)/%exclude \1/" >>$L/kcontrol

popd
rm -rf $T

# Create configuration menu
BRT=%buildroot
DTDR=%_datadir
LBDR=%_libdir
APPLNK=%applnk
KDEMENU=%kdemenu
MENUDIR=%_menudir
FLISTS=`pwd`/file_lists

what_package()
{
    for f in $FLISTS/*
    do
	if grep -v -e^\%\exclude $f | grep -e\/`basename $1`$ >/dev/null
	then
	    PACKAGE="%name-`basename $f`"
	    break
	fi
    done
    [ -z "$PACKAGE" ] && PACKAGE="%name-kcontrol"
    echo $PACKAGE
}

add2list()
{
    echo "$2"| sed "s/^\.\///" >>$FLISTS/`echo $1|sed "s/^%name\-//"`
}

pushd %buildroot

# .hidden
for f in ./$APPLNK/.hidden/*.desktop
do
    MNAME=$(echo "$(basename $f)"| sed "s/\.desktop$//")
    PACKAGE=`what_package $f`
    %Kd2m $PACKAGE ".hidden" $f $BRT/$MENUDIR/kcmshell-hidden-$MNAME kde
    add2list $PACKAGE $MENUDIR/kcmshell-hidden-$MNAME
done

# Configuration/Other
%Kd2m %name-kdeprint "Configuration/Printing" $BRT/$APPLNK/Settingsmenu/printmgr.desktop $BRT/$MENUDIR/%name-configuration-printmgr kde
add2list %name-kdeprint $MENUDIR/%name-configuration-printmgr
for f in ./$KDEMENU/*.desktop
do
    grep -eCategories\=.*Settings.*$ $f >/dev/null || continue

    MNAME=$(echo "$(basename $f)"| sed "s/\.desktop$//")
    KDE_ONLY=
    PACKAGE=
    case $MNAME in
	kappfinder)
	    continue
	    ;;
	kcmkicker|kmenuedit|kpersonalizer)
	    KDE_ONLY="kde"
	    ;;
	*)
	    ;;
    esac
    PACKAGE=`what_package $f`
    %Kd2m $PACKAGE "Configuration/Other" $f $BRT/$MENUDIR/kdebase-configuration-$MNAME $KDE_ONLY
    add2list $PACKAGE $MENUDIR/kdebase-configuration-$MNAME
done

# Configuration/KDE/
for f in ./$KDEMENU/*.desktop
do
    CTGR=`grep -eCategories\=.*{X-KDE-information,X-KDE-settings}.* $f| \
	sed "s/;$//" | \
	perl -pi -e "s/.*(X\-KDE\-settings.*)$/\1/" | \
	perl -pi -e "s/.*(X\-KDE\-information)$/\1/"`
    [ -z "$CTGR" ] && continue

    MNAME=$(echo "$(basename $f)"| sed "s/\.desktop$//")
    SECTION=
    PACKAGE=
    case $CTGR in
	X-KDE-information)
	    SECTION="Configuration/KDE/Information"
	;;
	X-KDE-settings-accessibility)
	    SECTION="Configuration/KDE/Accessibility"
	;;
	X-KDE-settings-components)
	    SECTION="Configuration/KDE/Components"
	;;
	X-KDE-settings-desktop)
	    SECTION="Configuration/KDE/Desktop"
	;;
	X-KDE-settings-looknfeel)
	    SECTION="Configuration/KDE/LookNFeel"
	;;
	X-KDE-settings-network)
	    SECTION="Configuration/KDE/Network"
	;;
	X-KDE-settings-webbrowsing)
	    SECTION="Configuration/KDE/Network/WebBrowsing"
	;;
	X-KDE-settings-peripherals)
	    SECTION="Configuration/KDE/Peripherals"
	;;
	X-KDE-settings-power)
	    SECTION="Configuration/KDE/PowerControl"
	;;
	X-KDE-settings-security)
	    SECTION="Configuration/KDE/Security"
	;;
	X-KDE-settings-sound)
	    SECTION="Configuration/KDE/Sound"
	;;
	X-KDE-settings-system)
	    SECTION="Configuration/KDE/System"
	;;
	*)
	    echo "Unknown configuration section - $SECTION"
	    exit 1
	;;
    esac
    PACKAGE=`what_package $f`
    %Kd2m $PACKAGE $SECTION $f $BRT/$MENUDIR/kcmshell-$MNAME kde
    add2list $PACKAGE $MENUDIR/kcmshell-$MNAME
done

